
package de.ivu.elect.presentation.stimmeingabe;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.stimmeingabe.boundary.StimmeingabePlausiKonfigurationConversationStore;
import de.ivu.elect.business.stimmeingabe.boundary.StimmeingabePlausiKonfigurationExtendedDAO;
import de.ivu.elect.business.stimmeingabe.boundary.StimmeingabePlausiKonfigurationEdit;
import de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfiguration;
import de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractStimmeingabePlausiKonfigurationEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractStimmeingabePlausiKonfigurationEditNoScopeView.VIEW_ID, useCase = UseCasePermission.STIMMEINGABE_PLAUSI_EDIT)
public abstract class AbstractStimmeingabePlausiKonfigurationEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<StimmeingabePlausiKonfiguration>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "stimmeingabePlausiKonfigurationEditView";

  public static final String VIEW_ID = "/stimmeingabe/stimmeingabe-plausi-konfiguration-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/stimmeingabe/stimmeingabe-plausi-konfiguration-search.xhtml";

  @Inject
  protected transient StimmeingabePlausiKonfigurationExtendedDAO extendedDAO;

  @Inject
  protected transient StimmeingabePlausiKonfigurationEdit edit;

  @Inject
  @ConversationGroup(StimmeingabePlausiKonfigurationConversationStore.class)
  protected transient StimmeingabePlausiKonfigurationConversationStore conversationStore;

  @Inject
  protected transient StimmeingabePlausiKonfigurationMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient StimmeingabePlausiKonfigurationEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public StimmeingabePlausiKonfiguration getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(StimmeingabePlausiKonfiguration entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.STIMMEINGABE_PLAUSI_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(StimmeingabePlausiKonfiguration entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.STIMMEINGABE_PLAUSI_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.STIMMEINGABE_PLAUSI_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.STIMMEINGABE_PLAUSI_EDIT)
  @Override
  public String save() {
    StimmeingabePlausiKonfiguration entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(StimmeingabePlausiKonfiguration entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    StimmeingabePlausiKonfiguration entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(StimmeingabePlausiKonfiguration entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.STIMMEINGABE_PLAUSI_EDIT);
  }
  
  @Redirect
  public String edit(StimmeingabePlausiKonfiguration entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class StimmeingabePlausiKonfigurationEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<StimmeingabePlausiKonfiguration,   de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationPK  > {

    private static final long serialVersionUID = 1L;
  }
}
